﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using Syncfusion.UI.Xaml.TreeGrid.Cells;

namespace SfDataGrid_ComboBoxDemo
{
    //Creating new renderer for the CustomColumn.
    public class GridCellComboBoxRendererExt : GridCellComboBoxRenderer //GridVirtualizingCellRenderer<ContentControl, ComboBox>
    {
        public GridCellComboBoxRendererExt() : base()
        { }

        public override bool CanUpdateBinding(GridColumn column)
        {
            return true; 
        }
        
        public override void OnInitializeEditElement(DataColumnBase dataColumn, ComboBox uiElement, object dataContext)
        {
            var customColumn = (GridComboBoxColumnExt)dataColumn.GridColumn;
            //Setting ItemsSource for GridComboBoxColumn
            if (customColumn != null && customColumn.ItemsSourceSelectorSelector != null)
            {
                object value = customColumn.ItemsSourceSelectorSelector.GetItemsSource(dataContext, DataGrid.DataContext);
                customColumn.ItemsSource = value as IEnumerable;
            }
            base.OnInitializeEditElement(dataColumn, uiElement, dataContext);
        }
    }
}
