﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.UI.Xaml.Grid.Helpers;
using SfDataGrid_ComboBoxDemo;
using System.Collections.ObjectModel;

namespace SfDataGrid_ComboBoxDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            //Adding renderer for GridComboBoxExt Column.
            if (!sfdatagrid.CellRenderers.ContainsKey("GridComboBoxExtRenderer"))
            {
                sfdatagrid.CellRenderers.Add("GridComboBoxExtRenderer", new GridCellComboBoxRendererExt());
            }
        }

        private void sfdatagrid_CurrentCellEndEdit(object sender, CurrentCellEndEditEventArgs args)
        {
            var sfDataGrid = sender as SfDataGrid;
            if (sfDataGrid.CurrentColumn.MappingName != "CountryName")
                return;
            //Updates the ShipId columns when changing the CountryName.
            var orderInfo = sfDataGrid.CurrentItem as OrderInfo;
            var viewModel = sfDataGrid.DataContext as ViewModel;
            var shipCities = viewModel.ShipCities[orderInfo.CountryName];
            orderInfo.CityID = shipCities.First().CityID;

            //this.sfdatagrid.UpdateDataRow(args.RowColumnIndex.RowIndex);
        }
    }

    //Creating a class for binding different ItemsSource for each row of GidComboBoxColumn.
        public class ItemsSourceSelectorSelector : IItemsSourceSelector
        {
            public IEnumerable GetItemsSource(object record, object dataContext)
            {
                if (record == null)
                    return null;

                var orderinfo = record as OrderInfo;
                var countryName = orderinfo.CountryName;

                var viewModel = dataContext as ViewModel;

                //Returns Shipcity collection based on CountryName.
                if (viewModel.ShipCities.ContainsKey(countryName))
                {
                    ObservableCollection<CityDetails> shipcities = null;
                    viewModel.ShipCities.TryGetValue(countryName, out shipcities);
                    return shipcities.ToList();
                }
                return null;
            }
        }
}
